/* this is an awful conf file reader which should be strenghen and enhanced */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "conf_file.h"
#include <sys/stat.h>
#include <sys/types.h>

#define CONF_DIR_NAME1 "/.config"
#define CONF_DIR_NAME2 "/.config/gnomess"
#define CONF_FILE_NAME "/.config/gnomess/conf.ini"
#define LINE_SIZE 1024

/****************************************************************************

add_section

 ****************************************************************************/
static section_t * add_section(conf_t *conf,const char * section)
{
	if(conf == NULL) return NULL;
	conf->nb_section++;
	conf->section_array=realloc(conf->section_array,conf->nb_section*sizeof(section_t *));
	if(conf->section_array==NULL) return NULL;
	conf->section_array[conf->nb_section-1]=malloc(sizeof(section_t));
	if(conf->section_array[conf->nb_section-1]==NULL ) return NULL; /*TODO manage previous memory allocation*/
	conf->section_array[conf->nb_section-1]->name = malloc(strlen(section)+1);
	if(conf->section_array[conf->nb_section-1]->name==NULL) return NULL; /*TODO manage previous memory allocation*/
	strcpy(conf->section_array[conf->nb_section-1]->name, section);
	conf->section_array[conf->nb_section-1]->nb_param=0;
	conf->section_array[conf->nb_section-1]->param_array=NULL;

	return conf->section_array[conf->nb_section-1];
}

/****************************************************************************

add_param

 ****************************************************************************/
static param_t * add_param(section_t *sec, const char * param, const char * data)
{
	if(sec == NULL) return NULL;
	sec->nb_param++;
	sec->param_array=realloc(sec->param_array,sec->nb_param*sizeof(param_t *));
	if(sec->param_array==NULL) return NULL;
	sec->param_array[sec->nb_param-1]=malloc(sizeof(param_t));
	if(sec->param_array[sec->nb_param-1]==NULL) return NULL; /* TODO : resize param_array */
	param_t * par = sec->param_array[sec->nb_param-1];
	/* Save the name of the param */
	par->name=malloc(strlen(param)+1);
	if(par->name==NULL) return NULL; /* TODO : remove param_array memory modification */
	strcpy(par->name,param);

	par->data=malloc(strlen(data)+1);
	if(par->data==NULL) return NULL; /* TODO : remove previous memory modification */
	strcpy(par->data,data);

	return par;
}
/****************************************************************************

reformat_line

****************************************************************************/

static int reformat_line(char * buffer)
{
	char *tmp;
	int i;
	int j=0;
	int first_entry=0; /* No useful data has been met yet */
	int second_entry=0; /* The trailing space between param name and data has not been set */

	if(strlen(buffer)>0)
		if(buffer[strlen(buffer)-1]=='\n') buffer[strlen(buffer)-1]=0;

	tmp=malloc(strlen(buffer)+1);
	if(tmp == NULL) return 1;

	memcpy(tmp,buffer,strlen(buffer)+1);
	bzero(buffer,strlen(tmp)+1);

	for(i=0;i<strlen(tmp);i++) {
		if(tmp[i] == '\t'||tmp[i] == ' ') {
			if(first_entry) {
				if(!second_entry) {
					second_entry=1;
					buffer[j++]=' ';
					continue;
				}
				else continue; /* Skip tab and space between param name and its data */
			}
			else continue; /* Skip tab and space before param name */
		}
		/* Copy data */
		if(second_entry) {
			memcpy(&(buffer[j]),&(tmp[i]),strlen(tmp+i)+1);
			free(tmp);
			return 0;
		}
		/* Copy param name */
		first_entry = 1;
		buffer[j++]=tmp[i];
	}

	free(tmp);
	return 0;
}

/****************************************************************************

get_param_and_data

****************************************************************************/

static void get_param_and_data(char * input, char * param, char * data)
{
	int i=0;
	int j=0;

	data[0]=0;
	param[0]=0;

	while(i<strlen(input)){
		if(input[i]!=' ')
			param[j++]=input[i];
		else {
			param[j]=0;
			strcpy(data, input+i+1);
			return;
		}
		i++;
	}
}

/****************************************************************************

conf_file_init

****************************************************************************/

int  conf_file_init(conf_t * conf)
{
	char buffer[LINE_SIZE];
	char buf_param[LINE_SIZE];
	char buf_data[LINE_SIZE];
	FILE *fd;

	conf->nb_section = 0;
	conf->section_array = NULL;

	sprintf(buffer,"%s%s",getenv ("HOME"),CONF_FILE_NAME);
	fd=fopen(buffer,"r");
	if(fd==NULL) return 1;

	while(fgets(buffer,LINE_SIZE,fd)!=NULL) {
		if(reformat_line(buffer)!=0) continue;

		if(buffer[0]==0) continue;
		if(buffer[0]=='#') continue;
		if(buffer[0]=='\n') continue;
		if(buffer[0]=='-') {
			add_section(conf,buffer+1);
		}
		else {
			get_param_and_data(buffer,buf_param,buf_data);
			section_t * section=conf->section_array[conf->nb_section-1];
			add_param(section,buf_param,buf_data);
		}
	}

	return 0;
}

/****************************************************************************

add_data_to_param_list


 ****************************************************************************/
static void add_data_to_param_list(const char *data,param_t *param)
{
	/* Check if data is already here */
	if( strstr(param->data,data) != NULL ) return;

	/* add the data */
	char * tmp = malloc(strlen(param->data)+strlen(data)+1+1); /* +1 ';' +1 terminating 0 */
	if(tmp==NULL) return;
	strcpy(tmp,param->data);
	strcat(tmp,";");
	strcat(tmp,data);

	/* save the data in the param */
	free(param->data);
	param->data=tmp;
}
/****************************************************************************

conf_set

if list is true,the param is added to existing params (unless it is already 
present )

 ****************************************************************************/
int conf_set(conf_t *conf, const char * section, const char * param, const char * data,int list)
{
	if(conf == NULL) return 1;
	if(section == NULL) return 1;
	if(param == NULL) return 1;
	if(data == NULL) return 1;
	/* look for the section */
	int i;
	for(i=0;i<conf->nb_section;i++) {
		/* section exists */
		if(strcmp(section,conf->section_array[i]->name)==0) {
			/* look for param */
			int j;
			section_t *sec = conf->section_array[i];
			for(j=0;j<sec->nb_param;j++) {
				if(strcmp(param,sec->param_array[j]->name)==0) {
					if(list==0) {
						param_t * par = sec->param_array[j];
						if( data == par->data) { /* avoid freeing what we need to copy */
							return 0;
						}
						if( data == NULL ) {
							free(par->data);
							par->data=NULL;
							return 0;
						}
						if( par->data != NULL && strcmp(data,par->data) == 0 ) { /* data is already up to date */
							return 0;
						}
						if( par->data != NULL ) { 
							free(par->data);
							par->data=NULL;
						}
						par->data=malloc(strlen(data)+1);
						if(par->data==NULL) return 1;
						if(strlen(data)==0) par->data[0]=0;
						else strcpy(par->data,data);
						return 0;
					}
					else {
						add_data_to_param_list(data,sec->param_array[j]);
						return 0;
					}
				}
			}
			/* param does not exist , add it + its data */
			return (add_param(sec,param,data) == NULL);
		}
	}
	/* section does not exist, add all*/
	return (add_param(add_section(conf,section),param,data)==NULL);
}

/****************************************************************************

conf_get

****************************************************************************/

const char * conf_get(conf_t *conf,const  char * section,const  char * param)
{
	int i;
	for(i=0;i<conf->nb_section;i++) {
		if(strcmp(section,conf->section_array[i]->name)==0) {
			int j;
			section_t *sec = conf->section_array[i];
			for(j=0;j<sec->nb_param;j++) {
				if(strcmp(param,sec->param_array[j]->name)==0) {
					return sec->param_array[j]->data;
				}
			}
		}
	}

	return NULL;
}

/****************************************************************************

conf_exit

 ****************************************************************************/
int conf_exit(conf_t *conf)
{
	char buffer[LINE_SIZE];
	FILE *fd;

	if(conf == NULL) return 1;

	sprintf(buffer,"%s%s",getenv ("HOME"),CONF_DIR_NAME1);
	mkdir(buffer,0775);
	sprintf(buffer,"%s%s",getenv ("HOME"),CONF_DIR_NAME2);
	mkdir(buffer,0775);
	
	sprintf(buffer,"%s%s",getenv ("HOME"),CONF_FILE_NAME);
	fd=fopen(buffer,"w");
	if(fd==NULL) return 1;

	int i;
	int j;
	/* look for the section */
	for(i=0;i<conf->nb_section;i++) {
		section_t *sec = conf->section_array[i];
		if( sec->name == NULL || strcmp(sec->name,"")==0 ) continue;
		if( fputs("-" , fd) < 0) return 1;
		if( fputs(sec->name , fd) < 0) return 1;
		if( fputs("\n" , fd) < 0) return 1;
		/* look for param */
		for(j=0;j<sec->nb_param;j++) {
			if( sec->param_array[j]->name == NULL || strcmp(sec->param_array[j]->name,"")==0 ) continue;
			if( sec->param_array[j]->data == NULL || strcmp(sec->param_array[j]->data,"")==0 ) continue;
			if( fputs("\t" , fd) < 0) return 1;
			if( fputs(sec->param_array[j]->name , fd) < 0) return 1;
			if( fputs("    " , fd) < 0) return 1;
			if( fputs(sec->param_array[j]->data , fd) < 0) return 1;
			if( fputs("\n" , fd) < 0) return 1;
		}
	}

	fclose(fd);
	return 0;
}
