#include <gtk/gtk.h>
#include <string.h>
#include "parse_data.h"
#include "conf_file.h"
#include "../config.h"

void SetSnapSelection(char * machine, GtkWidget * DeviceTree, conf_t *conf)
{
        GtkTreeModel*   model;
        GtkTreeIter     iter;
        GtkTreeSelection *sel;
	GtkListStore * DeviceListStore;
	gchar * DeviceName;
	const char * device;

	device = conf_get(conf,machine,"snap");
        DeviceListStore=GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(DeviceTree)));
        model = gtk_tree_view_get_model(GTK_TREE_VIEW(DeviceTree));
        sel=gtk_tree_view_get_selection(GTK_TREE_VIEW(DeviceTree));
	if( gtk_tree_model_get_iter_first (model,&iter) == FALSE ) return;
	if(device==NULL) {
		/* select first device if none already selected */
		gtk_list_store_set (DeviceListStore, &iter,4,1,-1);
		return;
	}
	do {
		gtk_tree_model_get (model,&iter,1,&DeviceName, -1);
		if(strcmp(DeviceName,device)==0) {
			gtk_list_store_set (DeviceListStore, &iter,4,1,-1);
		}
		else {
			gtk_list_store_set (DeviceListStore, &iter,4,0,-1);
		}
		g_free(DeviceName);
	}
	while( gtk_tree_model_iter_next(model,&iter) != FALSE );
}

void UnselectAllSnap(GtkWidget * DeviceTree)
{
        GtkTreeModel*   model;
        GtkTreeIter     iter;
        GtkTreeSelection *sel;
	GtkListStore * DeviceListStore;

        DeviceListStore=GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(DeviceTree)));
        model = gtk_tree_view_get_model(GTK_TREE_VIEW(DeviceTree));
        sel=gtk_tree_view_get_selection(GTK_TREE_VIEW(DeviceTree));
	if( gtk_tree_model_get_iter_first (model,&iter) == FALSE ) return;
	do {
		gtk_list_store_set (DeviceListStore, &iter,4,0,-1);
	}
	while( gtk_tree_model_iter_next(model,&iter) != FALSE );
}

void FillDeviceList(char * machine_name,GtkWidget * DeviceTree, llist_t * mess)
{
        GtkTreeIter iter;
	GtkListStore * DeviceListStore;
	int first=1;
	GdkPixbuf *pixbuf;
	char tmp[1024];
	llist_t * machine;

        DeviceListStore=GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(DeviceTree)));
        /* look for the right machine */
	machine = find_node_by_attr(mess,"machine","name",machine_name);

	if( machine == NULL) return;

	gtk_list_store_clear(DeviceListStore);
	/* iterate through all devices */	
	llist_t * device;
	device = find_first_node(machine,"device");
	while( device != NULL ) {
		llist_t * instance;
		instance = find_first_node(device,"instance");
		while ( instance != NULL ) {
			/*Read type image file */
			sprintf(tmp,"%s/gnomess/%s.png",DATADIR,find_attr(device,"type"));
			pixbuf = gdk_pixbuf_new_from_file(tmp,NULL);

			gtk_list_store_append (DeviceListStore, &iter);
			gtk_list_store_set (DeviceListStore, &iter,
					0, pixbuf,
					1, find_attr(instance,"name"),
					4, first,
					5, find_attr(device,"type"),
					6, 1, /* draw the widget as a radio button */
					-1);
			first = 0;
			if( pixbuf != NULL) g_object_unref (pixbuf);
			instance=find_next_node(instance);
		} 
		device=find_next_node(device);
	};
}
